USARTRXC:
		push temp1
		in temp1,SREG
		push temp1
		push temp2
		push temp4
		
		lds temp2,SSBitByte
		
		
		cbr temp2,1<<BitPE			;wenn PE = True dann ParityFehler und Bit setzen
		sbic UCSRA,PE
		sbr temp2,1<<BitPE

		in temp4,UDR
		
		cpi ByteZa,0
		breq AdresseErkannt
		rjmp DatenErkannt

AdresseErkannt:		
		sbrs temp2,BitPE				;wenn Byte = Adr und PE = TRUE dann sofort empfangen
		rjmp AdrAuswerten

AdrParityError:		
		rcall InitUSARTTra				;stoppen
		rjmp USARTRXCEnde		

AdrAuswerten:
		inc ByteZa		
		mov Adr,temp4					;Adr aus erstem Byte generieren
		andi Adr,0b00000111
		mov AnzRecBytes,temp4
		andi AnzRecBytes,0b11111000
		ror AnzRecBytes
		ror AnzRecBytes
		ror AnzRecBytes
		inc AnzRecBytes
		
		cpi Adr,EigAdr					;Auf eigene Adr vergleichen
		breq EigAdrSetzen
		cbr temp2,1<<BitEigAdr

		rjmp USARTRXCEnde

EigAdrSetzen:
		sbr temp2,1<<BitEigAdr
		
		in temp1,PIND
		sbrs temp1,PinPCSE
		rjmp USARTRXCEnde

		ldi temp1,PCaktivPreSc			;PCaktiv Counter wieder zurcksetzen, wenn PCSE = True
		sts SSZaPCaktiv,temp1
		rjmp USARTRXCEnde

DatenErkannt:
		sbrs temp2,BitEigAdr			;wenn Adr <> EigeneAdr war, dann Byte nicht speichern
		rjmp ByteNSp
		sbrc temp2,BitPE				;wenn Parity = True, dann Byte nicht speichern
		rjmp ByteNSp
		
		rcall ByteSpeichern
	
				

ByteNSp:		
		inc ByteZa
		cp ByteZa, AnzRecBytes
		brne USARTRXCEnde				;ByteZa < AnzRecBytes dann nach Ende	

		clr ByteZa
		
		ldi temp1,0						;Timer0 stoppen
		out TCCR0,temp1
		
		
		sbrs temp2,BitEigAdr
		rjmp USARTRXCEnde		
		cbr temp2,1<<BitEigAdr			;BitEigAdr wieder lschen
			

		
		
		rjmp USARTRXCEnde

USARTRXCEnde:		
		sts SSBitByte,temp2
		pop temp4
		pop temp2
		pop temp1
		out SREG,temp1
		pop temp1
		reti
;************************************************************************************************************

USARTTXC:
		push temp1
		in temp1,SREG
		push temp1
		push temp4		
		
		ldi temp1,0						;Timer0 zurcksetzen und starten
		out TCNT0,temp1
		
		ldi	zl,low(AnzByteTra*2)		;Anzahl der zu sendenden Bytes holen		
		ldi	zh,high(AnzByteTra*2)
	
		add zl,BusTeilnZa
		ldi temp1,0
		adc zh,temp1
		
		lpm temp1,z
		inc temp1		;das hier anders machen		
		
		inc ByteZa
		cp ByteZa,temp1
		breq TXCFertig

		
		rcall ByteLaden
		

		out UDR,temp4
		rjmp USARTTXCEnde

TXCFertig:			
						
		cbi PortD,PinSE					;Eigenen SendEnable auf empfangen stellen
		clr ByteZa
		rcall InitUSARTRec
		cpi BusTeilnZa,PCAdr
		breq PCWirdSenden
		rjmp USARTTXCEnde

PCWirdSenden:
		sbi PortD,PinPCSE				;PC SendEnable auf senden stellen
		
		
USARTTXCEnde:
		pop temp4
		pop temp1
		out SREG,temp1
		pop temp1
		reti


;************************************************************************************************************
ADCCC:		
		push temp1
		in temp1,SREG
		push temp1
		push temp4		
		
		in temp4, ADCH

		cpi Kanal,0x20
		breq Kanal0
		cpi Kanal,0x21
		breq Kanal1
		cpi Kanal,0x22
		breq Kanal2
		cpi Kanal,0x23
		breq Kanal3
		rjmp ADCCCFertig

Kanal0:
		sts SSADC0,temp4
		rjmp ADCCCFertig
Kanal1:		
		sts SSADC1,temp4
		rjmp ADCCCFertig
Kanal2:		
		sts SSADC2,temp4
		rjmp ADCCCFertig
Kanal3:		
		sts SSADC3,temp4
		rjmp ADCCCFertig
				
ADCCCFertig:		
				
		pop temp4
		pop temp1
		out SREG,temp1
		pop temp1	
		reti



;************************************************************************************************************

TC0OV:		
		push temp1
		in temp1,SREG
		push temp1
		push temp2
		push temp3
		push temp4
		
	
		rcall PCaktiv
			
     	
		
		lds temp1,SSZaT0		
		inc temp1
		sts SSZaT0,temp1
		cpi temp1,2		
		brsh NoStartADC		
		rjmp StartADC

NoStartADC:
		ldi temp1,1
		sts SSZaT0,temp1
		
		rcall InitUSARTTra		
		
		clr ByteZa						;Adresse und AnzBytes berechnen
		
		cbi PortD,PinPCSE				;wenn PC gesendet hat, dann hier SendEnable beenden
		
		
		lds temp1,SSBitByte1
		sbrc temp1,BitLCDBegOn
		nop
		
		
		rcall AnzDatenZ1
		
		rcall IstTasteGedr
		
		lds temp1,SSMenu
		cpi temp1,0
		in temp2,SREG
		sbrc temp2,Z
		rjmp MAnz
		cpi temp1,1
		in temp2,SREG
		sbrc temp2,Z
		rjmp MEinst
		cpi temp1,2
		in temp2,SREG
		sbrc temp2,Z
		rjmp MPara

MEinst:		
		rcall MEinstAuswTaste
		rjmp SESetzen
MAnz:		
		rcall MAnzAuswTaste
		rjmp SESetzen
MPara:		
		rcall MEinstAuswTaste
		rjmp SESetzen
				
				
SESetzen:
		rcall AusgDisplay		
		sbi PortD,PinSE					;SE auf schreiben setzen

		inc BusteilnZa
		cpi BusteilnZa, AnzBusTeiln
		brlo AdrAusgabe
		ldi BusTeilnZa,1				
		ldi temp1,0				;PC zum antworten lnger Zeit geben
		sts SSZaT0,temp1	
		rjmp AdrAusgabe

AdrAusgabe:		
		ldi	zl,low(AnzByteTra*2)		;Anzahl der zu sendenden Bytes holen		
		ldi	zh,high(AnzByteTra*2)
	
		add zl,BusTeilnZa
		ldi temp1,0
		adc zh,temp1
		
		lpm temp4,z		;anders machen

		;mov temp4,temp1				
		rol temp4	
		rol temp4
		rol temp4
		andi temp4,0b11111000			;AnzBytes berechnen
		
		add temp4,BusteilnZa 			;Controlleradr zuaddieren
		
		out UDR,temp4

		
		rjmp StartADC

StartADC:		
		;;sts SSZaT2,temp1
		;inc Kanal
		;cpi Kanal,0x24
		;brne KanalAusg
		;ldi Kanal,0x20
KanalAusg:
		;out ADMUX,Kanal
		;ldi temp1,0b11001110
		;out ADCSR,temp1					;ADC starten
		

				
		
TC0OVEnde:		
		pop temp4
		pop temp3
		pop temp2
		pop temp1
		out SREG,temp1
		pop temp1		
			
		reti

;*********************************************************************************************

TC1OV:
      set
		ldi temp3,TSTOP
      out TCCR1B,temp3
      reti

;************************************************************************************************************	

TC2OV:
      push temp1
		in temp1,SREG
		push temp1
		push temp2
	
	   in temp1,MCUCR
	   sbrc temp1,SE
	   rjmp TimeD2
	
		clt
		lds temp1,SSBitByte1		
		sbrs temp1,BitBlink
		set
		bld temp1,BitBlink
		sts SSBitByte1,temp1
		
		
				
		ldi temp1,':'                           ;Doppelpunkt bei Uhrzeit blinken lassen
		lds temp2,SSBitByte1
		sbrs temp2,BitBlink
		ldi temp1,' '		
		
		ldi yl,low(SSLcdRAMZ1)
		ldi yh,high(SSLcdRAMZ1)
		adiw yh:yl,EPUhrzeit + 2
		st y,temp1

TimeD2:		
		lds temp1,SST2Za
		cpi temp1,0
		breq OneSecond
		dec temp1
		sts SST2Za,temp1
		rjmp EndeTC2OV
		

OneSecond:		
		ldi temp1,1
		sts SST2Za,temp1		

      in temp1,MCUCR                      ;wenn PowerSave eingesch. ist, dann nur Zeit akt.
      sbrc temp1,SE
      rjmp Uhrzeit
		
		lds temp1,SSTaOKZa
		
		lds temp2,SSGewMenu                 ;je nach dem welches Men gewhlt wurde
		cpi temp2,MenuAnz                         ;den dazugehrigen Taster kontrollieren
		breq KontrTaOK
		cpi temp2,MenuEinst
		breq GewMenuEinst
		cpi temp2,MenuPara
		breq KontrTaPfLi
		rjmp Uhrzeit


GewMenuEinst:
		lds temp2,SSMenu
		cpi temp2,MenuAnz
		breq KontrTaPfLi
		cpi temp2,MenuPara
		breq KontrTaOK
		rjmp Uhrzeit


KontrTaPfLi:
		in temp2,PINB
		sbrc temp2,PinTaPfLi             ;wenn Taster losgelassen, dann Zhler lschen
		clr temp1
		rjmp DecTaOKZa


KontrTaOK:
		in temp2,PINC
		sbrc temp2,PinTaOK             ;wenn Taster losgelassen, dann Zhler lschen
		clr temp1
		rjmp DecTaOKZa	
		
DecTaOKZa:		
		cpi temp1,0
		breq ZspUhrzeit
		dec temp1
		cpi temp1,0
		breq TaOK3Sek
		rjmp Uhrzeit
		
ZspUhrzeit:
		rjmp Uhrzeit
				
TaOK3Sek:
		lds temp2,SSGewMenu          ;Moduswechsel durchfhren
		cpi temp2,0
		breq WechselZuMAnz
		cpi temp2,1
		breq WechselZuMEinst
		cpi temp2,2
		breq WechselZuMPara
		rjmp Uhrzeit
		
WechselZuMAnz:
		sts SSMenu,temp2
		clr temp2
		sts SSZeileCursor,temp2
				
		rjmp Uhrzeit

WechselZuMEinst:
      sts SSMenu,temp2
      clr temp2
		sts SSAktEbene,temp2
		sts SSZeileCursor,temp2		
		sts SSScroll,temp2
		sts SSEbene0,temp2
		
		push temp1
		rcall Ebene0WerteEinl
		pop temp1		
      			
		lds temp2,SSBitByte1
		cbr temp2,(1<<BitCursorBlinken|1<<BitMParaEingabe)		
		sts SSBitByte1,temp2		
      rjmp Uhrzeit

WechselZuMPara:
		sts SSMenu,temp2
      lds temp2,SSBitByte1                  ;CodeOK lschen
      cbr temp2,1<<BitCodeOK
		sts SSBitByte1,temp2
		clr temp1
		ldi zl,low(SSCodeL)                    ;Code lschen
		ldi zh,high(SSCodeL)
		st z,temp1
		ldi zl,low(SSCodeH)
		ldi zh,high(SSCodeH)
		st z,temp1
		
		ldi temp2,2
      sts SSAktEbene,temp2
		clr temp2
      sts SSZeileCursor,temp2
      sts SSEbene2,temp2
      sts SSScroll,temp2
      push temp1
		rcall Ebene2WerteEinl
		pop temp1
      rjmp Uhrzeit
      		
		
Uhrzeit:
		sts SSTaOKZa,temp1		
		
		ldi zl,low(SSUhrzeitS)
		ldi zh,high(SSUhrzeitS)
		ld temp1,z
		inc temp1
		cpi temp1,60
		breq ULSek
		st z,temp1
		rjmp EndeTC2OV

ULSek:
		clr temp1
		st z,temp1
		ldi zl,low(SSUhrzeitM)
		ldi zh,high(SSUhrzeitM)
		ld temp1,z
		inc temp1
		cpi temp1,60
		breq ULMin
		st z,temp1
		rjmp EndeTC2OV
		
ULMin:
		clr temp1
		st z,temp1
		ldi zl,low(SSUhrzeitH)
		ldi zh,high(SSUhrzeitH)
		ld temp1,z
		inc temp1
		cpi temp1,24
		breq ULTag
		st z,temp1
		rjmp EndeTC2OV
		
ULTag:
		clr temp1
		st z,temp1
		rjmp EndeTC2OV
		
EndeTC2OV:		
      in temp1,MCUCR
		sbrc temp1,SE
		rjmp PowerDown
		
		mov temp1,ROMCount		
		cpi temp1,0
		breq KeinTempFuehler
				
		mov temp1,ZaMStNr
		rcall GetTemp		
		
		inc ZaMStNr
		cp ROMCount,ZaMStNr
		in temp1,SREG
		sbrc temp1,Z
		clr ZaMStNr
		
KeinTempFuehler:
		
		pop temp2
		pop temp1
		out SREG,temp1
		pop temp1
		
		reti

;******************************************************************************************

EERDR:
      push temp1
      in temp1,SREG
      push temp1

		cbi EECR,EERIE
      lds temp1,SSAnzEE
      cpi temp1,1
      brne EndeEERDR           ;wenn Anz<>1, dann nix tun weil schon fertig

		dec temp1
		sts SSAnzEE,temp1
		rcall EEDat1Spei
		
EndeEERDR:
		pop temp1
		out SREG,temp1
		pop temp1
		reti

 ;*************************************************************************************









































































