
MEinstAuswTaste:
		lds temp1,SSTasten
		
		sbrc temp1,BitTaPfUn
		rjmp MEinstTaPfUn				
		
		sbrc temp1,BitTaPfOb
		rjmp MEinstTaPfOb
		
		sbrc temp1,BitTaPfLi
		rjmp MEinstTaPfLi
		
		sbrc temp1,BitTaPfRe
		rjmp MEinstTaPfRe
				
		sbrc temp1,BitTaOK		
		rjmp MEinstTaOK
		
		rcall MEinstAnz
		rcall AnzCursor
		
EndeMEinstAuswTaste:
		
		ret

;************************************************************************************


MEinstTaPfUn:

		lds temp1,SSBitByte1
		sbrc temp1,BitMEinstEingabe
		rjmp MEinstTaPfUnEingabe
		sbrc temp1,BitMParaEingabe
		rjmp MEinstTaPfUnEingabe		
		rjmp MEinstTaPfUnNoEingabe

MEinstTaPfUnEingabe:
		lds temp1,SSZeileCursor
		sts SSAnzZeile,temp1
		rcall MEinstE2DatenLaden
		rcall MEinstSSSuchen         ;RAM-Adresse in SS01 und Max-Wert in SS01Max
					
		lds zl,SS01L
		lds zh,SS01H
		ld temp3,z                   ;Wert der Speicherzelle in temp3 laden

		rcall MEinstAddWertSuchen    ;AddWert in SSAdd

		lds temp1,SSAdd	
		mov temp2,temp3					;alten Wert in temp2 sichern	
		sub temp3,temp1               ;wenn neuer Wert < als Min,dann alten Wert sp.

		lds temp1,SS01Min
		dec temp1
		cp temp1,temp3
				           			
      brlt WertGrMin
      mov temp3,temp2


WertGrMin:	
		lds zl,SS01L
		lds zh,SS01H		
      st z,temp3
		rjmp MEinstTaPfUnEnde
		

MEinstTaPfUnNoEingabe:

		lds temp1,SSAktEbene
      		
		cpi temp1,0
      breq TaPfUnE0		
		cpi temp1,1
      breq TaPfUnE1		
		cpi temp1,2
      breq TaPfUnE2

		rjmp EndeMEinstAuswTaste

TaPfUnE0:
		lds temp4,SSEbene0       ;wenn SSEbeneMax noch nicht erreicht, dann SSEbene0 + 1
		lds temp3,SSZeileCursor
		lds temp2,SSEbeneMax     ;und SSZeileCursor + 1 -> wenn SSZeileCursor > 2 dann
		lds temp1,SSScroll       ;SSZeileCursor - 1 und SSScroll + 1
		
		cp temp4,temp2
		in temp2,SREG
		sbrc temp2,C
		inc temp4
		sbrc temp2,C		
		inc temp3
		cpi temp3,3
		in temp2,SREG
		sbrs temp2,C
		dec temp3
		sbrs temp2,C
		inc temp1
		
		sts SSZeileCursor,temp3
		sts SSScroll,temp1		
		sts SSEbene0,temp4
		
		rcall Ebene0WerteEinl				
		rjmp MEinstTaPfUnEnde
		
TaPfUnE1:
		lds temp4,SSEbene1
		lds temp3,SSZeileCursor
		lds temp2,SSEbeneMax
		lds temp1,SSScroll
		cp temp4,temp2
		in temp2,SREG
		sbrc temp2,C
		inc temp4
		sbrc temp2,C
		inc temp3
		cpi temp3,3
		in temp2,SREG
		sbrs temp2,C
		dec temp3
		sbrs temp2,C
		inc temp1
		
		sts SSZeileCursor,temp3
		sts SSScroll,temp1		
		sts SSEbene1,temp4
		
		rcall Ebene1WerteEinl
		rjmp MEinstTaPfUnEnde

TaPfUnE2:
		lds temp4,SSEbene2
		lds temp3,SSZeileCursor
		lds temp2,SSEbeneMax
		lds temp1,SSScroll
		cp temp4,temp2
		in temp2,SREG
		sbrc temp2,C
		inc temp4
		sbrc temp2,C
		inc temp3
		cpi temp3,3
		in temp2,SREG
		sbrs temp2,C
		dec temp3
		sbrs temp2,C
		inc temp1
		
		sts SSZeileCursor,temp3
		sts SSScroll,temp1
		sts SSEbene2,temp4 				
		
		rcall Ebene2WerteEinl		
		rjmp MEinstTaPfUnEnde
		
MEinstTaPfUnEnde:	
		
		rjmp EndeMEinstAuswTaste
		
	


;*********************************************************************************************


MEinstTaPfOb:
      lds temp1,SSBitByte1
		sbrc temp1,BitMEinstEingabe
		rjmp MEinstTaPfObEingabe
		sbrc temp1,BitMParaEingabe
		rjmp MEinstTaPfObEingabe
		rjmp MEinstTaPfObNoEingabe

MEinstTaPfObEingabe:
		lds temp1,SSZeileCursor
		sts SSAnzZeile,temp1
		rcall MEinstE2DatenLaden
      rcall MEinstSSSuchen         ;RAM-Adresse in SS01 und Max-WErt in SS01Max
				
		lds zl,SS01L
		lds zh,SS01H
		ld temp3,z                   ;Wert der Speicherzelle in temp3 laden

		rcall MEinstAddWertSuchen     ;AddWert wird in SSAdd zurckgegeben

		lds temp1,SSAdd
		mov temp2,temp3					;alten Wert in temp2 sichern
		add temp3,temp1               ;wenn neuer Wert < als MaxWert,dann alten Wert sp.	
		brvs OldWert                  ;wenn Wert OV berschreitet, dann alten Wert sp.
				
		lds temp1,SS01Max
		cp temp1,temp3
		brlt OldWert
      rjmp NewWert

OldWert:			
      mov temp3,temp2
NewWert:	
		lds zl,SS01L
		lds zh,SS01H		
      st z,temp3
				
		rjmp MEinstTaPfObEnde		
		

MEinstTaPfObNoEingabe:

		lds temp1,SSAktEbene
      		
		cpi temp1,0
      breq TaPfObE0		
		cpi temp1,1
      breq TaPfObE1		
		cpi temp1,2
      breq TaPfObE2

		rjmp EndeMEinstAuswTaste

TaPfObE0:
		lds temp4,SSEbene0       ;wenn SSEbene0 grsser als SSEigEbeneMin dann SSEbene0 - 1
		lds temp3,SSZeileCursor
		lds temp2,SSEbeneMin
		lds temp1,SSScroll
		cp temp2,temp4
		in temp2,SREG
		sbrc temp2,C
		dec temp4
		sbrc temp2,C
		dec temp3
		cpi temp3,0xFF
		in temp2,SREG
		sbrs temp2,C
		inc temp3
		sbrs temp2,C
		dec temp1
		
		sts SSZeileCursor,temp3
		sts SSScroll,temp1		
		sts SSEbene0,temp4
		
		rcall Ebene0WerteEinl		
		rjmp MEinstTaPfObEnde
		
TaPfObE1:
		lds temp4,SSEbene1
		lds temp3,SSZeileCursor
		lds temp2,SSEbeneMin
		lds temp1,SSScroll
		cp temp2,temp4
		in temp2,SREG
		sbrc temp2,C
		dec temp4
		sbrc temp2,C
		dec temp3
		cpi temp3,0xFF
		in temp2,SREG
		sbrs temp2,C
		inc temp3
		sbrs temp2,C
		dec temp1
		
		sts SSZeileCursor,temp3
		sts SSScroll,temp1
		sts SSEbene1,temp4
		
		rcall Ebene1WerteEinl
		rjmp MEinstTaPfObEnde

TaPfObE2:
		lds temp4,SSEbene2
		lds temp3,SSZeileCursor
		lds temp2,SSEbeneMin
		lds temp1,SSScroll
		cp temp2,temp4
		in temp2,SREG
		sbrc temp2,C
		dec temp4
		sbrc temp2,C
		dec temp3
		cpi temp3,0xFF
		in temp2,SREG
		sbrs temp2,C
		inc temp3
		sbrs temp2,C
		dec temp1
		
		sts SSZeileCursor,temp3
		sts SSScroll,temp1
		sts SSEbene2,temp4		
		
		rcall Ebene2WerteEinl
		rjmp MEinstTaPfObEnde
		
MEinstTaPfObEnde:						
		
		rjmp EndeMEinstAuswTaste
		

;************************************************************************************

MEinstSSSuchen:		
		lds temp2,SSCursorIndex
		ldi temp1,4
		sub temp1,temp2
		lds temp2,SSZuordCISS 			
		
MEinstSSSuchenWe:
		ror temp2		              ;schiebe Bit von Speicherindex ins C
		dec temp1
		brne MEinstSSSuchenWe		
		brcc Speicherst0
		rjmp Speicherst1

Speicherst0:
      lds temp4,SS0L
      sts SS01L,temp4
      lds temp4,SS0H
      sts SS01H,temp4
      lds temp4,SS0Min
      sts SS01Min,temp4
		lds temp4,SS0Max
      sts SS01Max,temp4
      ret
Speicherst1:		
		lds temp4,SS1L
		sts SS01L,temp4
		lds temp4,SS1H
		sts SS01H,temp4
		lds temp4,SS1Min
		sts SS01Min,temp4
		lds temp4,SS1Max
		sts SS01Max,temp4		
		ret

;************************************************************************************

MEinstAddWertSuchen:
		lds temp2,SSMode
		ldi temp1,4		
		mul temp2,temp1
		
		lds temp1,SSCursorIndex 		
		
		add rel,temp1
		clr temp1
		adc reh,temp1
      ldi zl,low(AddCursorIndex*2)
      ldi zh,high(AddCursorIndex*2)
      add zl,rel
      adc zh,reh

		lpm temp1,z
		sts SSAdd,temp1
		ret


;*************************************************************************************

MEinstTaPfRe:

		lds temp1,SSBitByte1
		sbrc temp1,BitMEinstEingabe
		rjmp MEinstTaPfReEingabe
		sbrc temp1,BitMParaEingabe
		rjmp MEinstTaPfReEingabe
		lds temp1,SSMenu
		cpi temp1,MenuEinst
		breq MEinstTaPfReNoEingabe
		rjmp EndeMEinstTaPfRe

MEinstTaPfReEingabe:
		lds temp1,SSCursorIndex   			;wenn CursorIndex<3 dann +1
		cpi temp1,3
		in temp2,SREG
		sbrs temp2,Z
		inc temp1
		sts SSCursorIndex,temp1
		rcall AusgCursorPosition		
		
		rjmp EndeMEinstAuswTaste



MEinstTaPfReNoEingabe:
		lds temp1,SSAktEbene
      		
		cpi temp1,0
      breq TaPfReE0		
		cpi temp1,1
      breq TaPfReE1
		rjmp EndeMEinstTaPfRe

TaPfReE0:
		inc temp1		                    	;SSAktEbene + 1 und Werte von Ebene1 einlesen
		sts SSAktEbene,temp1		
		lds temp1,SSEbeneEinsp
		sts SSEbene1,temp1
		lds temp1,SSZeileCursor
		sts SSZeileCursorE0,temp1
		clr temp1
		sts SSZeileCursor,temp1
		lds temp1,SSScroll
		sts SSScrollE0,temp1
		clr temp1
		sts SSScroll,temp1
		rcall Ebene1WerteEinl
		rjmp EndeMEinstTaPfRe
		
TaPfReE1:
		inc temp1		                      ;SSAktEbene + 1 und Werte von Ebene2 einlesen
		sts SSAktEbene,temp1
		lds temp1,SSEbeneEinsp
		sts SSEbene2,temp1
		sts SSEbeneEinspE1,temp1
		lds temp1,SSZeileCursor
		sts SSZeileCursorE1,temp1
		clr temp1
		sts SSZeileCursor,temp1
		lds temp1,SSScroll
		sts SSScrollE1,temp1
		clr temp1
		sts SSScroll,temp1
		rcall Ebene2WerteEinl
		rjmp EndeMEinstTaPfRe
		

EndeMEinstTaPfRe:		
	
		rjmp EndeMEinstAuswTaste		


;*************************************************************************************

MEinstTaPfLi:
      lds temp1,SSAktEbene
		cpi temp1,0
		brne TaPfLiEbene12 						
											
TaPfLiEbene0:
		lds temp1,SSBitByte1
		sbrc temp1,BitMEinstEingabe
		rjmp EndeMEinstTaPfLi
		
		ldi temp1,3
		sts SSTaOKZa,temp1           ;Zhler fr 3 sek initialisieren
      ldi temp1,2
      sts SSGewMenu,temp1          ;Menu Anz vorwhlen
		

TaPfLiEbene12:
		lds temp1,SSBitByte1
		sbrc temp1,BitMEinstEingabe
		rjmp MEinstTaPfLiEingabe
		sbrc temp1,BitMParaEingabe
		rjmp MEinstTaPfLiEingabe
		lds temp1,SSMenu
		cpi temp1,MenuEinst
		breq MEinstTaPfLiNoEingabe
		rjmp EndeMEinstTaPfLi

MEinstTaPfLiEingabe:
		ldi temp1,4
		lds temp2,SSAnzCursorIndex
		sub temp1,temp2		
		lds temp2,SSCursorIndex   			;wenn CursorIndex>4-AnzCursorIndex0 dann -1
		cp temp1,temp2
		in temp1,SREG
		sbrs temp1,Z
		dec temp2
		sts SSCursorIndex,temp2
		rcall AusgCursorPosition		
		
		rjmp EndeMEinstTaPfLi

MEinstTaPfLiNoEingabe:
		lds temp1,SSAktEbene
      		
		cpi temp1,1
      breq TaPfLiE1		
		cpi temp1,2
      breq TaPfLiE2
		rjmp EndeMEinstTaPfLi

TaPfLiE1:
		dec temp1		                    	;SSAktEbene - 1 und Werte von Ebene0 einlesen
		sts SSAktEbene,temp1		
		rcall Ebene0WerteEinl
		lds temp1,SSZeileCursorE0
		sts SSZeileCursor,temp1
		lds temp1,SSScrollE0
		sts SSScroll,temp1
		rjmp EndeMEinstTaPfLi
		
TaPfLiE2:
		dec temp1		                      ;SSAktEbene - 1 und Werte von Ebene1 einlesen
		sts SSAktEbene,temp1
		rcall Ebene1WerteEinl
		lds temp1,SSZeileCursorE1
		sts SSZeileCursor,temp1
		lds temp1,SSScrollE1
		sts SSScroll,temp1
		rjmp EndeMEinstTaPfLi
		

EndeMEinstTaPfLi:		
		
		rjmp EndeMEinstAuswTaste		




;***********************************************************************************		

MEinstTaOK:
		lds temp1,SSAktEbene         ;wenn SSAktEbene = 2 und SSBitByte1.BitEingabe=F dann
		cpi temp1,0                  ;SSBitByte1.BitEingabe=T und Cursor,usw.einschalten.
		breq TaOKEbene0              ;wenn OK bei einer anderen Ebene gedrckt wird, dann
		cpi temp1,2
		breq TaOKEbene2
				
		rjmp EndeMEinstAuswTaste										

TaOKEbene0:		
		lds temp1,SSBitByte1
		sbrc temp1,BitMEinstEingabe
		rjmp EndeMEinstTaOK
		
		ldi temp1,3
		sts SSTaOKZa,temp1           ;Zhler fr 3 sek initialisieren
      ldi temp1,MenuAnz
      sts SSGewMenu,temp1          ;Menu Anz vorwhlen
		rjmp EndeMEinstTaOK

TaOKEbene2:		
		ldi temp1,3
		sts SSTaOKZa,temp1           ;Zhler fr 3 sek initialisieren
      ldi temp1,MenuEinst
      sts SSGewMenu,temp1

AbfEingabe:						
		lds temp1,SSBitByte1
		sbrc temp1,BitMEinstEingabe
		rjmp EingabeAUS
		sbrc temp1,BitMParaEingabe
		rjmp EingabeAUS
		rjmp EingabeEIN
		
EingabeEIN:
		lds temp1,SSMenu
		cpi temp1,MenuPara
		brne EingabeOn
		
		lds temp1,SSZeileCursor               ;wenn ZeileCursor<>0 oder SSScroll<>0 oder
		lds temp2,SSScroll                    ;BitCodeOK = 0 dann keine EingabeEIN bei MPara
		add temp1,temp2
		in temp2,SREG
		sbrc temp2,Z 		
		rjmp EingabeOn
		
      lds temp1,SSBitByte1
      sbrs temp1,BitCodeOK
      rjmp EndeMEinstTaOK

EingabeOn:		
		lds temp2,SSMenu
		cpi temp2,MenuEinst
		breq EingabeOnMEinst
		rjmp EingabeOnMPara

EingabeOnMEinst:		
		lds temp1,SSBitByte1
		sbr temp1,1<<BitMEinstEingabe
		sts SSBitByte1,temp1
      rcall AusgCursorPosition
      rcall CursorOn
      rjmp EndeMEinstTaOK

EingabeOnMPara:		
      lds temp1,SSBitByte1
		sbr temp1,1<<BitMParaEingabe
		sts SSBitByte1,temp1
		rcall AusgCursorPosition
      rcall CursorOn
      rjmp EndeMEinstTaOK

EingabeAUS:										    ;hier Modusabhngig die RAM Daten ins EEPROM sp.
      ldi zl,low(AnzSSMode*2)
      ldi zh,high(AnzSSMode*2)
      lds temp1,SSMode
      add zl,temp1
      clr temp1
      adc zh,temp1
      lpm temp1,z                           ;Anz von Daten fr das EEPROM speichern
      dec temp1
      sts SSAnzEE,temp1
		lds temp1,SS0L
		sts SSAdrEE0L,temp1                    ;Adressen von Daten fr das EEPROM speichern
		lds temp1,SS0H
		sts SSAdrEE0H,temp1
		lds temp1,SS1L
		sts SSAdrEE1L,temp1
		lds temp1,SS1H
		sts SSAdrEE1H,temp1
		rcall EEDat0Spei
		
		rcall CheckCode

		lds temp1,SSBitByte1
		cbr temp1,1<<BitMEinstEingabe
		cbr temp1,1<<BitMParaEingabe
		sts SSBitByte1,temp1
      rcall CursorOff
      rjmp EndeMEinstTaOK

EndeMEinstTaOK:
		
		rjmp EndeMEinstAuswTaste


;**********************************************************************************

AusgCursorPosition:
		lds temp1,SSZeileCursor
      cpi temp1,0
      breq TaOKZ2
      cpi temp1,1
      breq TaOKZ3
      cpi temp1,2
      breq TaOKZ4
      rjmp EndeMEinstTaOK

TaOKZ2:
		ldi temp1,0b11000000		
		rjmp AusgCursorPositionWe
TaOKZ3:
      ldi temp1,0b10010100
		rjmp AusgCursorPositionWe
TaOKZ4:
		ldi temp1,0b11010100
		rjmp AusgCursorPositionWe

AusgCursorPositionWe:
		lds temp3,SSCursorIndex3
		lds temp4,SSCursorIndex
		cpi temp4,0
		in temp2,SREG
		sbrc temp2,Z
		lds temp3,SSCursorIndex0
		cpi temp4,1
		in temp2,SREG
		sbrc temp2,Z
		lds temp3,SSCursorIndex1
		cpi temp4,2
		in temp2,SREG
		sbrc temp2,Z
		lds temp3,SSCursorIndex2
						
		add temp1,temp3		
      mov LCD_CursorPos,temp1
		rcall lcd_command
		rcall CursorOn		
		
		ret		

;***********************************************************************************



















